/* D.c 
   === */

/* Sessai version based on read_clock.c in gps_clock */

#ifdef __USAGE
D,DD,DDD,DDDD - show current time (including minor time)
    D    [-v]	: show current time on this QNX node
    DD   [-v]	: show current time on all alive QNX nodes
    DDD  [-v]	: show current time on all alive QNX nodes
    DDDD [-v]	: show current time on all alive QNX nodes and additional info
        -v	: verbose mode if specified
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/timers.h>	/* necessary for getclock function!!! */
#include <time.h>
#include <unistd.h>	/* for basename() */

#include <sys/types.h>
#include <sys/name.h>

/* for clock_report() !!!! */
#include <signal.h>
#include <sys/name.h>
#include <errno.h>
#include <sys/vc.h>
#include <sys/kernel.h>
/* #include <sys/sendmx.h>	*/
#include <sys/osinfo.h>

//char wdayname[7][4]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
static const char *wdayname[]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
static const char *weekday[]={
"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};

void main(int argc,char *argv[]){

int yr,month,day,hour,min,sec;
// int msec,usec;
int yday,wday;

  time_t sys_time;
  struct tm *gmt_time;
  struct timespec rtc;
  struct timespec res;
////char wdayname[7][4]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
//static const char *wdayname[]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
//static const char *weekday[]={
//"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
  char tz[16];
  long ysec;
  long y0sec,d0sec,dsec,y0day;

	int i,num_nids;
	static char alive[32];
	//pid_t pid,vid;
	//pid_t procpid;
	//nid_t nid;
	nid_t nids[32];

	struct _osinfo osdata;

	int v=0;

	if(argc>1)v=1;

	if(v)fprintf(stdout,"clock info on this node ....\n");

	if(qnx_osinfo(0,&osdata) == -1){
		fprintf(stderr,"qnx_osinfo failed\n");
		exit(-1);
	}
		//fprintf(fp,"CLK This is node %ld ...\n",osdata.nodename);

/* modified by Sessai */
//  sys_time = time(NULL);
  clock_gettime(CLOCK_REALTIME,&rtc);
  sys_time = (time_t) rtc.tv_sec;
  clock_getres(CLOCK_REALTIME,&res);

  gmt_time = gmtime(&sys_time);
  yr = gmt_time->tm_year + 1900;
  month = gmt_time->tm_mon + 1;
  day = gmt_time->tm_mday; 
  hour = gmt_time->tm_hour;
  min = gmt_time->tm_min;
  sec = gmt_time->tm_sec;

  yday = gmt_time->tm_yday +1;
  wday = gmt_time->tm_wday;

// msec = (int)((time_t)rtc.tv_nsec / 1000000L);	// ticksize = 10msec...
// usec = (int)(((time_t)rtc.tv_nsec / 1000L) % 1000L);	// no meaning...

  strcpy(tz,getenv("TZ"));

// fprintf(stdout,"%d/%02d/%02d %02d:%02d:%02d.%03d%03d\n",
//	yr,month,day,hour,min,sec,msec,usec);
//fprintf(stdout,"%d/%02d/%02d (%03d:%s) %02d:%02d:%02d.%09ld %s\n",
//	yr,month,day,yday,wdayname[wday],hour,min,sec,rtc.tv_nsec,tz);

  ysec=(long)(yday-1)*86400L+(long)hour*3600L+(long)min*60L+(long)sec;

//fprintf(stdout,
// "%2d %d/%02d/%02d (%03d:%s) %02d:%02d:%02d.%09ld %s (%10ldu/%8ldys/%ldus)\n",
  fprintf(stdout,
   "%2d %d/%02d/%02d (%03d:%s) %02d:%02d:%02d.%09ld %s %10ldu/%8ldys/%ldus\n",
	osdata.nodename,
	yr,month,day,yday,wdayname[wday],hour,min,sec,rtc.tv_nsec,tz,
	sys_time,ysec,res.tv_nsec/1000);

 //if((strcmp(argv[0],"D")==0) && (argc==1)) exit(0);
 if(strcmp(basename(argv[0]),"D")==0) exit(0);

	if(v)fprintf(stdout,"clock info on all the alive nodes ....\n");

	clock_report(stdout);
 //if((strcmp(argv[0],"DD")==0) && (argc==1)) exit(0);
 if(strcmp(basename(argv[0]),"DD")==0) exit(0);

	if(v)fprintf(stdout,"clock info on this node again....\n");

  clock_gettime(CLOCK_REALTIME,&rtc);
  sys_time = (time_t) rtc.tv_sec;
  clock_getres(CLOCK_REALTIME,&res);

  gmt_time = gmtime(&sys_time);
  yr = gmt_time->tm_year + 1900;
  month = gmt_time->tm_mon + 1;
  day = gmt_time->tm_mday; 
  hour = gmt_time->tm_hour;
  min = gmt_time->tm_min;
  sec = gmt_time->tm_sec;

  yday = gmt_time->tm_yday +1;
  wday = gmt_time->tm_wday;
  strcpy(tz,getenv("TZ"));
  ysec=(long)(yday-1)*86400L+(long)hour*3600L+(long)min*60L+(long)sec;

  dsec=                      (long)hour*3600L+(long)min*60L+(long)sec;
  y0sec=sys_time-ysec;
  d0sec=ysec-dsec;
  y0day=y0sec/86400L;

//fprintf(stdout,
//	"%d/%02d/%02d (%03d:%s) %02d:%02d:%02d.%09ld %s (%10ldu/%8ldys/%5ldds)\n",
//	yr,month,day,yday,wdayname[wday],hour,min,sec,rtc.tv_nsec,tz,
//	sys_time,ysec,dsec);
  fprintf(stdout,
   "%2d %d/%02d/%02d (%03d:%s) %02d:%02d:%02d.%09ld %s %10ldu/%8ldys/%5ldds\n",
	osdata.nodename,
	yr,month,day,yday,wdayname[wday],hour,min,sec,rtc.tv_nsec,tz,
	sys_time,ysec,dsec);

 //if((strcmp(argv[0],"DDD")==0) && (argc==1)) exit(0);
 if(strcmp(basename(argv[0]),"DDD")==0) exit(0);

  fprintf(stdout,"unix%10ld sec = y0  %10ld + ysec %8ld(d0 %8ld + dsec%5ld)\n",
		sys_time,y0sec,ysec,d0sec,dsec);
  fprintf(stdout,"unix%10ld sec = %5ld day + %5ld sec (365x%ldy+%ldleap+%ld) days\n",
		sys_time,sys_time/86400L,sys_time%86400L,
		y0day/365L,y0day%365L,ysec/86400L);
  fprintf(stdout,"y0  %10ld sec = %5ld day + %5ld sec (365x%ldy+%ldleap) days\n",
		y0sec,y0day,y0sec%86400L,y0day/365L,y0day%365L);
  fprintf(stdout,"ysec%10ld sec = %5ld day + %5ld sec\n",
		ysec,ysec/86400L,ysec%86400L);
  fprintf(stdout,"d0  %10ld sec = %5ld day + %5ld sec (yday=%03d)\n",
		d0sec,d0sec/86400L,d0sec%86400L,yday);
  fprintf(stdout,"dsec%10ld sec = %ld(%ld(%02dh)+%ld(%02dm))+%lds\n",
		dsec,dsec-(long)sec,(long)hour*3600L,hour,
		(long)min*60L,min,(long)sec);

#if 1
		fprintf(stdout,"Node %ld : ",osdata.nodename);
		fprintf(stdout,"QNX Ver %d  ",osdata.version);
		fprintf(stdout,"Rel %c\n",osdata.release);

		fprintf(stdout,"...PC: %s, ",osdata.machine);
		fprintf(stdout,"Boot: %c, ",osdata.bootsrc);
		fprintf(stdout,"Cpu/Fpu: %ld/%ld, ",osdata.cpu,osdata.fpu);
		fprintf(stdout,"CpuSpeed: %d, ",osdata.cpu_speed/96);
		fprintf(stdout,"Tick(usec): %d\n",osdata.tick_size);

		fprintf(stdout,"...Free/TotalMem: %d/%dk, ",
					osdata.freememk,osdata.totmemk);
		fprintf(stdout,"MaxProcNum: %d, ",osdata.num_procs);
		fprintf(stdout,"SysFlag: %x, ",osdata.sflags);

		fprintf(stdout,"TZ: %s ...",getenv("TZ"));
		fprintf(stdout,"\n");
#endif

#if 1
   /* alive -u .... */
	if((num_nids=qnx_net_alive(alive,32))==-1){
		fprintf(stderr,"qnx_net_alive() failed\n");
	}
		fprintf(stdout,"  alive node(s) : ");
	// for(i=1;i<=num_nids;i++){
	for(i=1;i<num_nids;i++){
		if(alive[i]) fprintf(stdout,"%2d ",i);
	}
		fprintf(stdout,"\n");
   /* nameloc ... */
		fprintf(stdout,"Name Locator(s) : ");
	for(i=0;i<qnx_name_locators(&nids);++i){
		fprintf(stdout,"%2ld ",nids[i]);
	}
		fprintf(stdout,"\n");
#endif

  exit(0);
}  

//###########################


void qnx_now(int *yr,int *mon,int *day,int *hour,int *min,int *sec,
		long *tnsec,int *tday) {
	time_t qnx_time;
	struct tm *gmt_time;
	struct timespec time_spec;
	/* int msec,usec,nsec; */

	/* qnx_time = time(NULL); */
	getclock(TIMEOFDAY,&time_spec);
	qnx_time = (time_t)time_spec.tv_sec;
	gmt_time = gmtime(&qnx_time);
	*yr   = gmt_time->tm_year + 1900;
	*mon  = gmt_time->tm_mon + 1;
	*day  = gmt_time->tm_mday;
	*hour = gmt_time->tm_hour;
	*min  = gmt_time->tm_min;
	*sec  = gmt_time->tm_sec;
	*tday = gmt_time->tm_yday + 1;	/* 1/1 = 1 */
	*tnsec = time_spec.tv_nsec;
	//	*msec = (int)(time_spec.tv_nsec/1000000L);
	//	*usec = (int)((time_spec.tv_nsec/1000L)%1000L);
	//	*nsec = (int)(time_spec.tv_nsec%1000000L);
	return;
}

//int remote_qnx_now(int node,int *yr,int *mon,int *day,
//		int *hour,int *min,int *sec,long *tnsec,int *tday) {
int remote_qnx_now(int node,int *yr,int *mon,int *day,
		int *hour,int *min,int *sec,long *tnsec,
		int *tday,int *wday,long *tv_sec,long *ysec,
		unsigned short *tick) {
	nid_t nid;
	pid_t procpid;

	time_t qnx_time;
	struct tm *gmt_time;
	struct timespec time_spec;
	/* int msec,usec,nsec; */

	struct _osinfo osdata;

	nid=(nid_t)node;
	if( (procpid = qnx_vc_attach(nid,PROC_PID,0,_VC_AT_SHARE) )==-1){
		perror("qnx_vc_attach");
		return -1;
	}

	if(qnx_osinfo(nid,&osdata) == -1){
		fprintf(stderr,"qnx_osinfo for node %d failed\n",node);
		qnx_vc_detach(procpid);
		return -3;
	}
	*tick = osdata.tick_size;
	/* qnx_time = time(NULL); */
	// getclock(TIMEOFDAY,&time_spec);
	if (qnx_getclock(procpid,TIMEOFDAY,&time_spec)==-1){
		perror("qnx_get_clock");
		qnx_vc_detach(procpid);
		return -2;
	}
		qnx_vc_detach(procpid);

	qnx_time = (time_t)time_spec.tv_sec;
	gmt_time = gmtime(&qnx_time);
	*yr   = gmt_time->tm_year + 1900;
	*mon  = gmt_time->tm_mon + 1;
	*day  = gmt_time->tm_mday;
	*hour = gmt_time->tm_hour;
	*min  = gmt_time->tm_min;
	*sec  = gmt_time->tm_sec;
	*tday = gmt_time->tm_yday + 1;	/* 1/1 = 1 */
	*wday = gmt_time->tm_wday;	/* Sun = 0 */
	*tnsec = time_spec.tv_nsec;
	/*	msec = (int)(time_spec.tv_nsec/1000000L);
		usec = (int)((time_spec.tv_nsec/1000L)%1000L);
		nsec = (int)(time_spec.tv_nsec%1000000L);
	 */
	*tv_sec=qnx_time;
	*ysec=(long)(*tday-1)*86400L
		+(long)(*hour)*3600L+(long)(*min)*60L+(long)(*sec);
	return 0;
}

int doy(int *yr,int *mon,int *day){

	/* calculate day of the year and return it.
	 *	1/1=1
	 */
	int tday,leap;

	//if(*yr%4==0)leap=1;
	//else        leap=0;
	leap=(*yr%4==0);
	if(*yr%100==0)leap=0;
	if(*yr%400==0)leap=1;

	if(*mon== 1)      tday=*day;
	else if(*mon== 2) tday=*day     + 31;
	else if(*mon== 3) tday=*day+leap+ 59;
	else if(*mon== 4) tday=*day+leap+ 90;
	else if(*mon== 5) tday=*day+leap+120;
	else if(*mon== 6) tday=*day+leap+151;
	else if(*mon== 7) tday=*day+leap+181;
	else if(*mon== 8) tday=*day+leap+212;
	else if(*mon== 9) tday=*day+leap+243;
	else if(*mon==10) tday=*day+leap+273;
	else if(*mon==11) tday=*day+leap+304;
	else if(*mon==12) tday=*day+leap+334;
	else		  tday= -1;

	return tday;
}

/* ------------------------------------------------------------ */

int clock_report(FILE *fp) {

	int yr,mon,day,hr,min,sec,tday,msec,usec;
	int yr1,mon1,day1,hr1,min1,sec1,tday1,wday1;
	int yr2,mon2,day2,hr2,min2,sec2,tday2,wday2;
	long tnsec,tnsec1,tnsec2,tv_sec1,ysec1;
	unsigned short tick1;

	/* time_t qnx_time; */
	/* struct tm *gmt_time; */
	/* struct timespec time_spec; */

	int i,flg,num_nids,n;

	static char alive[32];

	pid_t pid,vid;
	pid_t procpid;
	nid_t nid;
	nid_t nids[32];

	struct _osinfo osdata;

//	fprintf(fp,"OSinfo & remote clock Report .....................\n");

   /* OSinfo... */

	if(qnx_osinfo(0,&osdata) != -1){
#if 0
		fprintf(fp,"Node %ld : ",osdata.nodename);
		fprintf(fp,"QNX Ver %d  ",osdata.version);
		fprintf(fp,"Rel %c\n",osdata.release);

		fprintf(fp,"...PC: %s, ",osdata.machine);
		fprintf(fp,"Boot: %c, ",osdata.bootsrc);
		fprintf(fp,"Cpu/Fpu: %ld/%ld, ",osdata.cpu,osdata.fpu);
		fprintf(fp,"CpuSpeed: %d, ",osdata.cpu_speed/96);
		fprintf(fp,"Tick(usec): %d\n",osdata.tick_size);

		fprintf(fp,"...Free/TotalMem: %d/%dk, ",
					osdata.freememk,osdata.totmemk);
		fprintf(fp,"MaxProcNum: %d, ",osdata.num_procs);
		fprintf(fp,"SysFlag: %x, ",osdata.sflags);
#endif
	}


   /* This node is ... */

	/* For this to work, 'export NODE' is required before running me.
	 * If 'NODE' is not exported, n will be 0...
	 * 	if( (n=atoi(getenv("NODE"))) != 0)
	 *		fprintf(fp,"This is node %d ...\n",n);
	 */
	/* This works fine at any time! */
	// fprintf(fp,"CLK This is node %ld ...\n",osdata.nodename);

   /* Time Zone of this node... */

#if 0
	fprintf(fp,"TZ: %s ...",getenv("TZ"));

	fprintf(fp,"\n");
#endif

   /* alive -u .... */

	if((num_nids=qnx_net_alive(alive,32))==-1){
		fprintf(fp,"qnx_net_alive() failed\n");
	}
	/*
		fprintf(fp,"  alive node(s) : ");
	// for(i=1;i<=num_nids;i++){
	for(i=1;i<num_nids;i++){
		if(alive[i]) fprintf(fp,"%2d ",i);
	}
		fprintf(fp,"\n");
	*/

   /* This node is ... AGAIN!!! */

	for(i=1;i<num_nids;i++){
		if(alive[i]){
			nid=(nid_t)i;
		   if((procpid=qnx_vc_attach(nid,PROC_PID,0,_VC_AT_SHARE))==-1){
			fprintf(fp,"CLK qnx_vc_attach() failed\n");
		   }
			qnx_vc_detach(procpid);
		   if(procpid == PROC_PID){
			if(i!=osdata.nodename){
			    fprintf(fp,"CLK This is node %d ...",i);
			    fprintf(fp," ... Aryaaa?!?!?!...\n");
			}
		   }
		}
	}

#if 0
   /* print `alive -u` here.... */

		fprintf(fp,"  alive node(s) : ");
	// for(i=1;i<=num_nids;i++){
	for(i=1;i<num_nids;i++){
		if(alive[i]) fprintf(fp,"%2d ",i);
	}
		fprintf(fp,"\n");

   /* nameloc ... */

		fprintf(fp,"Name Locator(s) : ");
	for(i=0;i<qnx_name_locators(&nids);++i){
		fprintf(fp,"%2ld ",nids[i]);
	}
		fprintf(fp,"\n");
#endif

   /* OS clocks on alive nodes... */

	for(n=1;n<num_nids;n++){
	    if(alive[n]){
		//remote_qnx_now(n,&yr1,&mon1,&day1,
		//		&hr1,&min1,&sec1,&tnsec1,&tday1);
		remote_qnx_now(n,&yr1,&mon1,&day1,
				&hr1,&min1,&sec1,&tnsec1,&tday1,
				&wday1,&tv_sec1,&ysec1,&tick1);
		//fprintf(fp,
		//    "node %d QNX %d/%2d/%2d (%03d) %2d:%02d:%02d.%09ld\n",
		//		n,yr1,mon1,day1,tday1,hr1,min1,sec1,tnsec1);
		fprintf(fp,
		    "%2d %d/%02d/%02d (%03d:%s) %2d:%02d:%02d.%09ld utc?? %10ldu/%8ldys/%uus\n",
				n,yr1,mon1,day1,tday1,wdayname[wday1],
				hr1,min1,sec1,tnsec1,tv_sec1,ysec1,tick1);

	    }
	}

	return 0;
}

//void main(){
//	clock_report(stdout);
//	exit(0);
//}
