#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dirent.h>	//for [open|read|close]dir
#include <time.h>	//for time_t,struct tm,gmtime();
#include <unistd.h>	//for access();

#ifdef __USAGE
	ftime - show 4 time stamps of a file(f/m/a/c)... by Sessai@NIPR
	ftime [-a|-c|-m|-f] <file name>
		-a display atime (access time)		(in unix time)
		-c display ctime (creation time)	(in unix time)
		-m display mtime (modified time)	(in unix time)
		-f display ftime (file time??)		(in unix time)
#endif

//time_t file_mtime(char *fullpath);
time_t file_mtime(char *fullpath,int mode);
void usage();

void usage(){
	fprintf(stderr,"ftime - show 4 time stamps of a file(f/m/a/c)... by Sessai@NIPR\n");
	fprintf(stderr,"\tftime [-a|-c|-m|-f] <file name>\n");
	fprintf(stderr,"\t\t-a display atime (access time)\n");
	fprintf(stderr,"\t\t-c display ctime (creation time)\n");
	fprintf(stderr,"\t\t-m display mtime (modified time)\n");
	fprintf(stderr,"\t\t-f display ftime (file time??)\n");
	exit(-1);
};

void main(int argc,char *argv[]){
	//char fullpath[128]="/radops/scripts/SDSCH.N.debug";
	char fullpath[256]="";
	time_t t;
	struct tm tms;
	int flag=0;

	if(argc==1){
		usage();
	}

	if(argc>1)strcpy(fullpath,argv[1]);
	//printf("argv1=%s\n",fullpath);
	if(strcmp(fullpath,"-a")==0)flag='a';
	if(strcmp(fullpath,"-m")==0)flag='m';
	if(strcmp(fullpath,"-c")==0)flag='c';
	if(strcmp(fullpath,"-f")==0)flag='f';
	//printf("flag=%c\n",flag);
	if(flag == 0){
		//printf("all mode\n");
	} else {
		if(argc>2){
			strcpy(fullpath,argv[2]);
		} else usage();
	}
	if((strcmp(fullpath,"")==0)){
		fprintf(stderr,"filename is NULL, exit...\n");
		exit(-1);
	}
	if(access(fullpath,R_OK)==-1){
		//fprintf(stderr,"the file does not exist or unreadable, exit...\n");
		fprintf(stderr,"the file %s does not exist or unreadable, exit...\n",fullpath);
		exit(-1);
	}

	if((flag == 0 )||(flag == 'f')){
		if((t=file_mtime(fullpath,0))==-1L){
			fprintf(stderr,"file_mtime failed, exit...\n");
			exit(-1);
		}
		tms=*gmtime(&t);
		//_gmtime(&t,&tms);
	    if(flag == 'f'){
		//fprintf(stdout,"ftime %s = %ld\n",fullpath,(unsigned long)t);
		//fprintf(stdout,"%ld\n",(unsigned long)t);
		fprintf(stdout,"%lu\n",(unsigned long)t);
		exit(0);
	    }
	    if(flag == 0){
		//fprintf(stdout,"ftime of %s = %d/%d/%d %02d:%02d:%02d (%ld)\n",
		//fprintf(stdout,"ftime of %s = %d/%d/%d %02d:%02d:%02d (%lu,%ld)\n",
		fprintf(stdout,
			"ftime of %s = %4d/%2d/%2d %02d:%02d:%02d (%10lu,%11ld)\n",
			fullpath,tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
			tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t,t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,t);
	    }
	}

	if((flag == 0 )||(flag == 'm')){
		if((t=file_mtime(fullpath,1))==-1L){
			fprintf(stderr,"file_mtime failed, exit...\n");
			exit(-1);
		}
		tms=*gmtime(&t);
		//_gmtime(&t,&tms);
	    if(flag == 'm'){
		//fprintf(stdout,"mtime %s = %ld\n",fullpath,(unsigned long)t);
		//fprintf(stdout,"%ld\n",(unsigned long)t);
		fprintf(stdout,"%lu\n",(unsigned long)t);
		exit(0);
	    }
	    if(flag == 0){
		//fprintf(stdout,"mtime of %s = %d/%d/%d %02d:%02d:%02d (%ld)\n",
		//fprintf(stdout,"mtime of %s = %d/%d/%d %02d:%02d:%02d (%lu,%ld)\n",
		fprintf(stdout,
			"mtime of %s = %4d/%2d/%2d %02d:%02d:%02d (%10lu,%11ld)\n",
			fullpath,tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
			tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t,t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,t);
	    }
	}

	if((flag == 0 )||(flag == 'a')){
		if((t=file_mtime(fullpath,2))==-1L){
			fprintf(stderr,"file_mtime failed, exit...\n");
			exit(-1);
		}
		tms=*gmtime(&t);
		//_gmtime(&t,&tms);
	    if(flag == 'a'){
		//fprintf(stdout,"atime %s = %ld\n",fullpath,(unsigned long)t);
		//fprintf(stdout,"%ld\n",(unsigned long)t);
		fprintf(stdout,"%lu\n",(unsigned long)t);
		exit(0);
	    }
	    if(flag == 0){
		//fprintf(stdout,"atime of %s = %d/%d/%d %02d:%02d:%02d (%ld)\n",
		//fprintf(stdout,"atime of %s = %d/%d/%d %02d:%02d:%02d (%lu,%ld)\n",
		fprintf(stdout,
			"atime of %s = %4d/%2d/%2d %02d:%02d:%02d (%10lu,%11ld)\n",
			fullpath,tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
			tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t,t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,t);
	    }
	}

	if((flag == 0 )||(flag == 'c')){
		if((t=file_mtime(fullpath,3))==-1L){
			fprintf(stderr,"file_mtime failed, exit...\n");
			exit(-1);
		}
		tms=*gmtime(&t);
		//_gmtime(&t,&tms);
	    if(flag == 'c'){
		//fprintf(stdout,"ctime %s = %ld\n",fullpath,(unsigned long)t);
		//fprintf(stdout,"%ld\n",(unsigned long)t);
		fprintf(stdout,"%lu\n",(unsigned long)t);
		exit(0);
	    }
	    if(flag == 0){
		//fprintf(stdout,"ctime of %s = %d/%d/%d %02d:%02d:%02d (%ld)\n",
		//fprintf(stdout,"ctime of %s = %d/%d/%d %02d:%02d:%02d (%lu,%ld)\n",
		fprintf(stdout,
			"ctime of %s = %4d/%2d/%2d %02d:%02d:%02d (%10lu,%11ld)\n",
			fullpath,tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
			tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t,t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,(unsigned long)t);
		//	tms.tm_hour,tms.tm_min,tms.tm_sec,t);
	    }
	}

	exit(0);
}

time_t file_mtime(char *fullpath,int mode){
	DIR *dirp;
	struct dirent *direntp;
	char node[_MAX_NODE];
	char dir[_MAX_DIR];
	char fn[_MAX_FNAME];
	char ext[_MAX_EXT];
	char ndir[_MAX_NODE+_MAX_DIR];
	char fnext[_MAX_FNAME+_MAX_EXT];
	time_t t=-1L;
	struct tm tms;

	_splitpath(fullpath,node,dir,fn,ext);
	//	fprintf(stdout,"%s : %s %s %s %s ...\n",
	//			fullpath,node,dir,fn,ext);
	strcpy(ndir,node);strcat(ndir,dir);
	if(strcmp(ndir,"")==0)strcpy(ndir,"./");
	strcpy(fnext,fn);strcat(fnext,ext);
	//	fprintf(stdout,"%s %s ...\n",ndir,fnext);
	if(access(ndir,R_OK)==-1){
		fprintf(stderr,"the dir does not exist or unreadable, exit...\n");
		return(-1);
	}
	dirp=opendir(ndir);
	if(dirp==NULL){
		fprintf(stderr,"file_mtime:opendir FAILED! exit\n");
		return -1L;
	}
	while(1){
		direntp=readdir(dirp);
		if(direntp==NULL)break;
		if(strcmp(direntp->d_name,fnext)!=0)continue;
	if(mode==0)
		t=direntp->d_stat.st_ftime;
		//	fprintf(stdout,"f:%ld: %s",t,asctime(gmtime(&t)));
	if(mode==1)
		t=direntp->d_stat.st_mtime;
		//	fprintf(stdout,"m:%ld: %s",t,asctime(gmtime(&t)));
	if(mode==2)
		t=direntp->d_stat.st_atime;
		//	fprintf(stdout,"a:%ld: %s",t,asctime(gmtime(&t)));
	if(mode==3)
		t=direntp->d_stat.st_ctime;
		//	fprintf(stdout,"c:%ld: %s",t,asctime(gmtime(&t)));
	}
	closedir(dirp);
	if(t==-1L){
		fprintf(stderr,"file_mtime:file does NOT exist! exit\n");
		return -1L;
	}
	return t;
}
