#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//#include <dirent.h>	//for [open|read|close]dir
#include <time.h>	//for time_t,struct tm,gmtime();
//#include <unistd.h>	//for access();
#include <unistd.h>	//for basename();

#ifdef __USAGE
ut2ymdhms - convert unix time to UTC... by Sessai@NIPR
ut2ymdhms [-c|-C|-s|-S] [-d|-t] UnixTime
	UnixTime : seconds since 00:00:00 UTC on Jan. 1, 1970
	output will be "yr mo dy hr mn sc" unless you specify any options
	-d : if specified, output will be "yr mo dy" only
	-t : if specified, output will be "hr mn sc" only
	-c (only) : if specified, output will be "YYYYMMDD hhmmss"
	-C (only) : if specified, output will be "YYYYMMDDhhmmss"
	-s (only) : if specified, output will be "YYYY/MM/DD hh:mm:ss"
	-S (only) : if specified, output will be "YYYY/MM/DD hh:mm:ss"
	"-c -d" or "-C -d" : if specified, output will be "YYYYMMDD"
	"-c -t" or "-C -t" : if specified, output will be "hhmmss"
	"-s -d" or "-S -d" : if specified, output will be "YYYY/MM/DD"
	"-s -t" or "-S -t" : if specified, output will be "hh:mm:ss"
ut2ymd = "ut2ymdhms -d"
ut2hms = "ut2ymdhms -t"
"ut2ymd -c"= "ut2ymdhms -c -d"
"ut2hms -c"= "ut2ymdhms -c -t"
ut2ymdc = "ut2ymdhms -c -d"
ut2hmsc = "ut2ymdhms -c -t"
ut2ymdS = "ut2ymdhms -s -d"
ut2hmsS = "ut2ymdhms -s -t"
ut2ymdhmsc = "ut2ymdhms -c"
ut2ymdhmsC = "ut2ymdhms -C"
ut2ymdhmsS = "ut2ymdhms -s"
#endif

#if 0
void usage(int argc,char *argv[]){
	//fprintf(stderr,"%s - convert unix time to UTC... by Sessai@NIPR\n",argv[0]);
	//fprintf(stderr,"%s [-d] UnixTime\n",argv[0]);
	fprintf(stderr,"ut2ymdhms - convert unix time to UTC... by Sessai@NIPR\n");
	fprintf(stderr,"ut2ymdhms [-c|-C|-s|-S] [-d|-t] UnixTime\n");
	fprintf(stderr,"\tUnixTime : seconds since 00:00:00 UTC on Jan. 1, 1970\n");
	fprintf(stderr,"\toutput will be \"yr mo dy hr mn sc\" unless you specify any options\n");
	fprintf(stderr,"\t-d : if specified, output will be \"yr mo dy\" only\n");
	fprintf(stderr,"\t-t : if specified, output will be \"hr mn sc\" only\n");
	fprintf(stderr,"\t\"-c -d\" or \"-C -d\" : if specified, output will be \"YYYYMMDD\"\n");
	fprintf(stderr,"\t\"-c -t\" or \"-C -t\" : if specified, output will be \"hhmmss\"\n");
	fprintf(stderr,"\t-c (only) : if specified, output will be \"YYYYMMDD hhmmss\"\n");
	fprintf(stderr,"\t-C (only) : if specified, output will be \"YYYYMMDDhhmmss\"\n");
	fprintf(stderr,"\t-s (only) : if specified, output will be \"YYYY/MM/DD hh:mm:ss\"\n");
	fprintf(stderr,"\t-S (only) : if specified, output will be \"YYYY/MM/DD hh:mm:ss\"\n");
	fprintf(stderr,"ut2ymd = \"ut2ymdhms -d\"\n");
	fprintf(stderr,"ut2hms = \"ut2ymdhms -t\"\n");
	fprintf(stderr,"\"ut2ymd -c\"= \"ut2ymdhms -c -d\"\n");
	fprintf(stderr,"\"ut2hms -c\"= \"ut2ymdhms -c -t\"\n");
	fprintf(stderr,"\"ut2ymdc\"= \"ut2ymdhms -c -d\"\n");
	fprintf(stderr,"\"ut2hmsc\"= \"ut2ymdhms -c -t\"\n");
	fprintf(stderr,"\"ut2ymdS\"= \"ut2ymdhms -s -d\"\n");
	fprintf(stderr,"\"ut2hmsS\"= \"ut2ymdhms -s -t\"\n");
	fprintf(stderr,"\"ut2ymdhmsc\"= \"ut2ymdhms -c\"\n");
	fprintf(stderr,"\"ut2ymdhmsC\"= \"ut2ymdhms -C\"\n");
	fprintf(stderr,"\"ut2ymdhmsS\"= \"ut2ymdhms -s\"\n");
	exit(-1);
};
#else
void usage(int argc,char *argv[]){
	char cmd[48];
	strcpy(cmd,"use ");
	strcat(cmd,argv[0]);
	strcat(cmd," 1>&2");
	system(cmd);
	exit(-1);
}
#endif


void main(int argc,char *argv[]){
	time_t t;
	struct tm tms;
	int mode=0,optflag=0;
	int cmp=0,optflag2=0;

	if(argc<2){
		usage(argc,argv);
	}
	if(strcmp(argv[1],"-c")==0){cmp=1;optflag2=1;}
	if(strcmp(argv[1],"-C")==0){cmp=2;optflag2=1;}
	if(strcmp(argv[1],"-s")==0){cmp=-1;optflag2=1;}
	if(strcmp(argv[1],"-S")==0){cmp=-1;optflag2=1;}
	if(argc<2+optflag2){
		usage(argc,argv);
	}
	if(strcmp(argv[1+optflag2],"-d")==0){mode=1;optflag=1;}
	if(strcmp(argv[1+optflag2],"-t")==0){mode=2;optflag=1;}

	if(strcmp(basename(argv[0]),"ut2ymd")==0){mode=1;}
	if(strcmp(basename(argv[0]),"ut2hms")==0){mode=2;}
	if(strcmp(basename(argv[0]),"ut2ymdc")==0){mode=1;cmp=1;}
	if(strcmp(basename(argv[0]),"ut2hmsc")==0){mode=2;cmp=1;}
	if(strcmp(basename(argv[0]),"ut2ymdS")==0){mode=1;cmp=-1;}
	if(strcmp(basename(argv[0]),"ut2hmsS")==0){mode=2;cmp=-1;}
	if(strcmp(basename(argv[0]),"ut2ymdhmsc")==0){mode=0;cmp=1;}
	if(strcmp(basename(argv[0]),"ut2ymdhmsC")==0){mode=0;cmp=2;}
	if(strcmp(basename(argv[0]),"ut2ymdhmsS")==0){mode=0;cmp=-1;}

	if(argc != 2+optflag+optflag2){
		usage(argc,argv);
	}

	t=atol(argv[1+optflag+optflag2]);
	tms=*gmtime(&t);
	//_gmtime(&t,&tms);


	//fprintf(stdout,"unix time of %ld = %d/%d/%d %02d:%02d:%02d UTC\n",
	//fprintf(stdout,"unix time of %lu = %d/%d/%d %02d:%02d:%02d UTC\n",
	//		(unsigned long)t,
	//		tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
	//		tms.tm_hour,tms.tm_min,tms.tm_sec);
	if(mode==1){
		if(cmp>0){
			fprintf(stdout,"%04d%02d%02d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday);
		}else if(cmp<0){
			fprintf(stdout,"%04d/%02d/%02d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday);
		}else	fprintf(stdout,"%d %d %d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday);
	} else if(mode==2){
		if(cmp>0){
			fprintf(stdout,"%02d%02d%02d\n",
				tms.tm_hour,tms.tm_min,tms.tm_sec);
		}else if(cmp<0){
			fprintf(stdout,"%02d:%02d:%02d\n",
				tms.tm_hour,tms.tm_min,tms.tm_sec);
		}else	fprintf(stdout,"%d %d %d\n",
				tms.tm_hour,tms.tm_min,tms.tm_sec);
	} else {
		if(cmp==2){
			fprintf(stdout,"%04d%02d%02d%02d%02d%02d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
				tms.tm_hour,tms.tm_min,tms.tm_sec);
		} else if(cmp==1){
			fprintf(stdout,"%04d%02d%02d %02d%02d%02d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
				tms.tm_hour,tms.tm_min,tms.tm_sec);
		} else if(cmp==-1){
			fprintf(stdout,"%04d/%02d/%02d %02d:%02d:%02d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
				tms.tm_hour,tms.tm_min,tms.tm_sec);
		} else {
			//fprintf(stdout,"%d %d %d %02d %02d %02d\n",
			fprintf(stdout,"%d %d %d %d %d %d\n",
				tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
				tms.tm_hour,tms.tm_min,tms.tm_sec);
		}
	}
	exit(0);
}

