#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>	//for time_t,struct tm,gmtime();
#include <unistd.h>	//for basename();

#ifdef __USAGE
%C - convert unix time to year and yaersec... by Sessai@NIPR
%C [-s] UnixTime
	UnixTime : seconds since 00:00:00 UTC on Jan. 1, 1970
	output will be "year yaersec" unless you specify '-s' option
	-s : if specified, output will be "yaersec" only
#endif

void usage(int argc,char *argv[]){
	fprintf(stderr,"%s - convert unix time to year and yearsec... by Sessai@NIPR\n",basename(argv[0]));
	fprintf(stderr,"%s [-s] UnixTime\n",basename(argv[0]));
	fprintf(stderr,"\tUnixTime : seconds since 00:00:00 UTC on Jan. 1, 1970\n");
	fprintf(stderr,"\toutput will be \"year yearsec\" unless you specify \'-s\' option\n");
	fprintf(stderr,"\t-s : if specified, output will be \"yearsec\" only\n");
	exit(-1);
};

void main(int argc,char *argv[]){
	time_t t;
	struct tm tms;
	int mode=0;
	unsigned long ysec;
	int yr,mo,dy,hr,mn,sc,lp,yd;

	if(argc<2){
		usage(argc,argv);
	}
	if(strcmp(argv[1],"-s")==0)mode=1;
	if(argc != 2+mode){
		usage(argc,argv);
	}

	t=atol(argv[1+mode]);
	tms=*gmtime(&t);
	//_gmtime(&t,&tms);

//	ysec=ymdhms2ys(tms.tm_year+1900,tms.tm_mon+1,tms.tm_mday,
//			tms.tm_hour,tms.tm_min,tms.tm_sec);

//--------
	yr=tms.tm_year+1900;
	mo=tms.tm_mon+1;
	dy=tms.tm_mday;
	hr=tms.tm_hour;
	mn=tms.tm_min;
	sc=tms.tm_sec;

	//lp=(yr%4==0);
	//if ( yr % 100  == 0 ) lp=0;
	//if ( yr % 400  == 0 ) lp=1;

	// not use mktime to be safe for any year...
	yd=md2yd(yr,mo,dy);	// Jan. 1 = 1 (not 0!!!)

	yd--;			// Jan. 1 = 0 !!!

	ysec=(unsigned long)yd*86400L+(unsigned long)hr*3600L
		+(unsigned long)mn*60L+(unsigned long)sc;
//--------

	if(mode){
		fprintf(stdout,"%lu\n",ysec);
	} else
		fprintf(stdout,"%d %lu\n",tms.tm_year+1900,ysec);

	exit(0);
}

//unsigned long ymdhms2ys(int yr,int mo,int dy,int hr,int mn,int sc){
//long ymdhms2ys(int yr,int mo,int dy,int hr,int mn,int sc){
//long int ymdhms2ys(int yr,int mo,int dy,int hr,int mn,int sc){
int ymdhms2ys(int yr,int mo,int dy,int hr,int mn,int sc){
	int leap,yd;
	struct tm tms;
	unsigned long ysec;
	//long ysec;

	//XXXXleap=((yr % 4) ? 1 : 0);
	leap=(yr%4==0);
	if ( yr % 100  == 0 ) leap=0;
	if ( yr % 400  == 0 ) leap=1;

	// not use mktime to be safe for any year...
	yd=md2yd(yr,mo,dy);	// Jan. 1 = 1 (not 0!!!)

	yd--;			// Jan. 1 = 0 !!!

	ysec=(unsigned long)yd*86400L+(unsigned long)hr*3600L
		+(unsigned long)mn*60L+(unsigned long)sc;

	return ysec;
}

//###################################################################
//#struct  tm {
//#        int  tm_sec;    /* seconds after the minute -- [0,61] */
//#        int  tm_min;    /* minutes after the hour   -- [0,59] */
//#        int  tm_hour;   /* hours after midnight     -- [0,23] */
//#        int  tm_mday;   /* day of the month         -- [1,31] */
//#        int  tm_mon;    /* months since January     -- [0,11] */
//#        int  tm_year;   /* years since 1900                   */
//#        int  tm_wday;   /* days since Sunday        -- [0,6]  */
//#        int  tm_yday;   /* days since January 1     -- [0,365]*/
//#        int  tm_isdst;  /* Daylight Savings Time flag */
//#};
//###################################################################

int md2yd(int yr,int mo,int dy){
/* a small function to calculate
 *	year day(total day) from year, month, day
 *	(1/1=1)
 */
	int leap,yd;

	//XXXXleap=((yr % 4) ? 1 : 0);
	leap=(yr%4==0);
	if ( yr % 100  == 0 ) leap=0;
	if ( yr % 400  == 0 ) leap=1;

	if ( mo <   0 )yd=0;
	if ( mo >  12 )yd=0;
	if ( mo ==  0 )yd=0;
	if ( mo ==  1 )yd=dy;
	if ( mo ==  2 )yd=dy+31;
	if ( mo ==  3 )yd=dy+leap+59;
	if ( mo ==  4 )yd=dy+leap+90;
	if ( mo ==  5 )yd=dy+leap+120;
	if ( mo ==  6 )yd=dy+leap+151;
	if ( mo ==  7 )yd=dy+leap+181;
	if ( mo ==  8 )yd=dy+leap+212;
	if ( mo ==  9 )yd=dy+leap+243;
	if ( mo == 10 )yd=dy+leap+273;
	if ( mo == 11 )yd=dy+leap+304;
	if ( mo == 12 )yd=dy+leap+334;

	//printf("yr=%d,mo=%d,dy=%d => yd=%d\n",yr,mo,dy,yd);

	return yd;
}

void monday(int *yr,int *mon,int *mday,int *yday) {
/* a small function to calculate
 *	mon (1-12), mday (1-31)  from  yr,yday(Jan.1=1)
 *				by Sessai@NIPR
 */

        int leap;

	leap=(*yr%4==0);
	if ( *yr % 100  == 0 ) leap=0;
	if ( *yr % 400  == 0 ) leap=1;

	if     (*yday <  1)     {*mon= 0;*mday=0;}
	else if(*yday<= 31)     {*mon= 1;*mday=*yday;}
	else if(*yday<= 59+leap){*mon= 2;*mday=*yday- 31;}
	else if(*yday<= 90+leap){*mon= 3;*mday=*yday- 59-leap;}
	else if(*yday<=120+leap){*mon= 4;*mday=*yday- 90-leap;}
	else if(*yday<=151+leap){*mon= 5;*mday=*yday-120-leap;}
	else if(*yday<=181+leap){*mon= 6;*mday=*yday-151-leap;}
	else if(*yday<=212+leap){*mon= 7;*mday=*yday-181-leap;}
	else if(*yday<=243+leap){*mon= 8;*mday=*yday-212-leap;}
	else if(*yday<=273+leap){*mon= 9;*mday=*yday-243-leap;}
	else if(*yday<=304+leap){*mon=10;*mday=*yday-273-leap;}
	else if(*yday<=334+leap){*mon=11;*mday=*yday-304-leap;}
	else if(*yday<=365+leap){*mon=12;*mday=*yday-334-leap;}
	else                    {*mon=0;*mday=0;}
        return;
}

