/* Sessai version */
#ifdef __USAGE
ymdhmsnow - display yr mo dy hr mn sc now
		or time relative to current time
		or time relative to any given time
ymdhmsnow [-v [-v] ] [-c|-C|-s|-S] [-d|-t|-2h]
			 [-e YYYY MM DD hh mm ss]
			 [+Y|-Y yr] [+M|-M mo] [+D|-D dy]
			 [+h|-h hr] [+m|-m mn] [+s|-s sc]
	output will be "yr mo dy hr mn sc"	if no options specified
	output will be "yr mo dy"		if '-d' specified
	output will be "hr mn sc"		if '-t' specified
	output will be "YYYY/MM/DD hh:mm:ss"	if '-s' or '-S' specified
	output will be "YYYYMMDD hhmmss"	if '-c' specified
	output will be "YYYYMMDDhhmmss"	if '-C' specified
	output will be "YYYY/MM/DD"		if '-s -d' or '-S -d' specified
	output will be "YYYYMMDD"		if '-c -d' or '-C -d' specified
	output will be "hh:mm:ss"		if '-s -t' or '-S -t' specified
	output will be "hhmmss"		if '-c -t' or '-C -t' specified
	if argv[0]="ymdnow" or "today", equivalent to "ymdhmsnow -d"
	if argv[0]="hmsnow"           , equivalent to "ymdhmsnow -t"
	if argv[0]="ymdh2hB" or an option "-2h" specified,
		output will be "YYYY MM DD hh"
		output will be "YYYY/MM/DD hhh"	if '-S' or '-s'also specified
		output will be "YYYYMMDDhh"	if '-C' also specified
	   or
		output will be "YYMMDDhh"	if '-c' also specified
	   where
		hh = int(<hournow or hour of epoch>/2)*2;

	-v 	: verbose disoplay ("-v -v" is more verbose)
	-e YYYY MM DD hh mm ss :
		  use this time as epoch time rather than current time!!!
	+Y n	: display time n years after now
	-Y n	: display time n years before now
	+M n	: display time n months after now
	-M n	: display time n months before now
	+D n	: display time n days after now
	-D n	: display time n days before now
	+h n	: display time n hours after now
	-h n	: display time n hours before now
	+m n	: display time n minutes after now
	-m n	: display time n minutes before now
	+s n	: display time n seconds after now
	-s n	: display time n seconds before now
	** the order of all options should be described as above

	*limitation should be as follows... no check in this program!!!
	-2147483648			<sc<=	                 2147483648
	-2147483648/60<-35791314	<mn<=	  35791314<=     2147483648/60
	-2147483648/3600<-596523	<hr<=	    596523<=     2147483648/3600
	-2147483648	<(hrnow+hr)*3600+(mnnow+mn)*60+scnow+sc<=2147483648
	-2147483648		<(yrnow+yr)*12+(monow+mo)<=      2147483648
		(256*256*256*256/2=2147483648)
#endif

#include <stdlib.h>
#include <stdio.h>
//#include <string.h>
//#include <sys/timers.h>	/* necessary for getclock function!!! */
#include <time.h>
#include <unistd.h>	/* for basename() */

//static const char *wdayname[]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
//static const char *weekday[]={
//"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};

void usage(int argc,char *argv[]){
	char cmd[48];
	strcpy(cmd,"use ");
	strcat(cmd,argv[0]);
	strcat(cmd," 1>&2");
	system(cmd);
	exit(-1);
}

void main(int argc,char *argv[]){

int yr,mo,dy,hr,mn,sc;
//int yday,wday;

  time_t sys_time;
  struct tm *gmt_time;
  struct timespec rtc;

  int optflag=0;
  int mode=0;
  int cmp=0;
//int cmp2=0;

  long addyr=0;
  long addmo=0;
  long adddy=0;
  long addhr=0;
  long addmn=0;
  long addsc=0;

	int ym;
	long ts;
	int newyr;
	int newmo;
	int newdy;
	int newhr;
	int newmn;
	int newsc;
	long newyd;
	int tmpyd;
  int shownow=1;
  int epoch=0;
  int v=0;

	if(strcmp(basename(argv[0]),"ymdnow")==0)mode=1;
	if(strcmp(basename(argv[0]),"today")==0)mode=1;
	if(strcmp(basename(argv[0]),"hmsnow")==0)mode=2;
	if(strcmp(basename(argv[0]),"ymdh2hB")==0)mode=3;
if(argc>1+optflag){
	if(strcmp(argv[1+optflag],"-v")==0){optflag++;v++;}
}
if(argc>1+optflag){
	if(strcmp(argv[1+optflag],"-v")==0){optflag++;v++;}
}
if(argc>1+optflag){
	if(strcmp(argv[1+optflag],"-c")==0){optflag++;cmp=1;}
	else if(strcmp(argv[1+optflag],"-C")==0){optflag++;cmp=2;}
	else if(strcmp(argv[1+optflag],"-s")==0){optflag++;cmp=-1;}
	else if(strcmp(argv[1+optflag],"-S")==0){optflag++;cmp=-1;}
}
if(argc>1+optflag){
	if(strcmp(argv[1+optflag],"-d")==0){optflag++;mode=1;}
	else if(strcmp(argv[1+optflag],"-t")==0){optflag++;mode=2;}
	else if(strcmp(argv[1+optflag],"-2h")==0){optflag++;mode=3;}
}

if(argc>1+optflag){
	if(strcmp(argv[1+optflag],"-e")==0){
		optflag++;
		if(argc<1+optflag+6)usage(argc,argv);
		yr=atoi(argv[1+optflag+0]);
		mo=atoi(argv[1+optflag+1]);
		dy=atoi(argv[1+optflag+2]);
		hr=atoi(argv[1+optflag+3]);
		mn=atoi(argv[1+optflag+4]);
		sc=atoi(argv[1+optflag+5]);
		optflag+=6;
		shownow=0;		// ok?!?!!!!
		epoch=1;
		//printf("epoch=%d/%d/%d %d:%d:%d\n",yr,mo,dy,hr,mn,sc);
	}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"+Y")==0){
		addyr=atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"-Y")==0){
		addyr=-atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"+M")==0){
		addmo=atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"-M")==0){
		addmo=-atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"+D")==0){
		adddy=atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"-D")==0){
		adddy=-atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"+h")==0){
		addhr=atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"-h")==0){
		addhr=-atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"+m")==0){
		addmn=atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"-m")==0){
		addmn=-atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"+s")==0){
		addsc=atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
if(argc==1+optflag+1)usage(argc,argv);
if(argc>1+optflag+1){
	if(strcmp(argv[1+optflag],"-s")==0){
		addsc=-atol(argv[1+optflag+1]);optflag+=2;shownow=0;}
}
//if(v)fprintf(stderr,"ADD %d/%d/%d %d:%d:%d\n",addyr,addmo,adddy,addhr,addmn,addsc);

if(epoch==0){
	//sys_time = time(NULL);
	clock_gettime(CLOCK_REALTIME,&rtc);
	sys_time = (time_t) rtc.tv_sec;
	//clock_getres(CLOCK_REALTIME,&res);

	gmt_time = gmtime(&sys_time);
	yr = gmt_time->tm_year + 1900;
	mo = gmt_time->tm_mon + 1;
	dy = gmt_time->tm_mday; 
	hr = gmt_time->tm_hour;
	mn = gmt_time->tm_min;
	sc = gmt_time->tm_sec;

	//yday = gmt_time->tm_yday +1;
	//wday = gmt_time->tm_wday;
}

//ysec=(long)(yday-1)*86400L+(long)hr*3600L+(long)mn*60L+(long)sc;

//strcpy(tz,getenv("TZ"));

//fprintf(stdout,
// "%2d %d/%02d/%02d (%03d:%s) %02d:%02d:%02d.%09ld %s %10ldu/%8ldys/%ldus\n",
//	osdata.nodename,
//	yr,mo,dy,yday,wdayname[wday],hr,mn,sc,rtc.tv_nsec,tz,
//	sys_time,ysec,res.tv_nsec/1000);
if((v)||(shownow)){
 if(mode==1){
  if(cmp>0){	fprintf(stdout,"%04d%02d%02d\n",yr,mo,dy);
  }else if(cmp<0){
		fprintf(stdout,"%04d/%02d/%02d\n",yr,mo,dy);
  }else		fprintf(stdout,"%d %2d %2d\n",yr,mo,dy);
 } else if(mode==2){
  if(cmp>0){	fprintf(stdout,"%02d%02d%02d\n",hr,mn,sc);
  }else if(cmp<0){
		fprintf(stdout,"%02d%02d%02d\n",hr,mn,sc);
  }else		fprintf(stdout,"%d %2d %2d\n",hr,mn,sc);
 } else if(mode==3){
  if(cmp==2){
	fprintf(stdout,"%04d%02d%02d%02d\n",yr,mo,dy,(int)(hr/2)*2);
  }else if(cmp==1){
	fprintf(stdout,"%02d%02d%02d%02d\n",yr%100,mo,dy,(int)(hr/2)*2);
  }else if(cmp==-1){
	fprintf(stdout,"%04d/%02d/%02d %02dh\n",yr,mo,dy,(int)(hr/2)*2);
  }else	fprintf(stdout,"%d %2d %2d %2d\n",yr,mo,dy,(int)(hr/2)*2);
 } else {
  if(cmp==2){
	fprintf(stdout,"%04d%02d%02d%02d%02d%02d\n",yr,mo,dy,hr,mn,sc);
  }else if(cmp==1){
	fprintf(stdout,"%04d%02d%02d %02d%02d%02d\n",yr,mo,dy,hr,mn,sc);
  }else if(cmp==-1){
	fprintf(stdout,"%04d/%02d/%02d %02d:%02d:%02d\n",yr,mo,dy,hr,mn,sc);
  }else	fprintf(stdout,"%d %2d %2d %2d %2d %2d\n",yr,mo,dy,hr,mn,sc);
 }
}
if(shownow){
 exit(0);
}
if(v>1)fprintf(stderr,"ADD %d/%d/%d %d:%d:%d\n",addyr,addmo,adddy,addhr,addmn,addsc);


	ym=((long)yr+addyr)*12L+((long)mo+addmo);
if(v>1)fprintf(stderr,"(yrnow+addyr)*12+(monow+addmo)=%ld\n",ym);
	newyr=(int)((ym-1L)/12L);
	newmo=(int)((ym-1L)%12L)+1;
	ts=((long)hr+addhr)*3600L+((long)mn+addmn)*60L+(long)sc+addsc;
if(v>1)fprintf(stderr,"(hrnow+addhr)*3600+(mnnow+addmn)*60+scnow+addsc=%ld\n",ts);
	//if(ts<0L){
		while(ts<0L){
			ts+=86400L;
			adddy--;
		}
	//}
	//if(ts>=86400L){
		while(ts>=86400L){
			ts-=86400L;
			adddy++;
		}
	//}
	newhr=(int)(ts/3600L);
	newmn=(int)(ts/60L)%60;
	newsc=(int)(ts%60L);

	newyd=(long)md2yd(newyr,newmo,dy)+adddy;
	//if(newyd>(long)md2yd(newyr,12,31)){
		while(newyd>(long)md2yd(newyr,12,31)){
			newyd -= (long)md2yd(newyr,12,31);
			newyr++;
		}
	//}
	//if(newyd<1L){
		while(newyd<1L){
			newyd += (long)md2yd(newyr-1,12,31);
			newyr--;
		}
	//}
	tmpyd=(int)newyd;
	monday(&newyr,&newmo,&newdy,&tmpyd);

if(mode==1){
  if(cmp>0){	fprintf(stdout,"%04d%02d%02d\n",newyr,newmo,newdy);
  }else if(cmp<0){
		fprintf(stdout,"%04d/%02d/%02d\n",newyr,newmo,newdy);
  }else		fprintf(stdout,"%d %2d %2d\n",newyr,newmo,newdy);
} else if(mode==2){
  if(cmp>0){	fprintf(stdout,"%02d%02d%02d\n",newhr,newmn,newsc);
  }else if(cmp<0){
		fprintf(stdout,"%04d/%02d/%02d\n",newhr,newmn,newsc);
  }else		fprintf(stdout,"%d %2d %2d\n",newhr,newmn,newsc);
 } else if(mode==3){
  if(cmp==2){
	fprintf(stdout,"%04d%02d%02d%02d\n",newyr,newmo,newdy,(int)(newhr/2)*2);
  }else if(cmp==1){
	fprintf(stdout,"%02d%02d%02d%02d\n",newyr%100,newmo,newdy,(int)(newhr/2)*2);
  }else if(cmp==-1){
	fprintf(stdout,"%04d/%02d/%02d %02dh\n",newyr%100,newmo,newdy,(int)(newhr/2)*2);
  }else	fprintf(stdout,"%d %2d %2d %2d\n",newyr,newmo,newdy,(int)(newhr/2)*2);
} else
  if(cmp==2){
	fprintf(stdout,"%04d%02d%02d%02d%02d%02d\n",newyr,newmo,newdy,newhr,newmn,newsc);
  }else if(cmp==1){
	fprintf(stdout,"%04d%02d%02d %02d%02d%02d\n",newyr,newmo,newdy,newhr,newmn,newsc);
  }else if(cmp==-1){
	fprintf(stdout,"%04d/%02d/%02d %02d:%02d:%02d\n",newyr,newmo,newdy,newhr,newmn,newsc);
  }else	fprintf(stdout,"%d %2d %2d %2d %2d %2d\n",newyr,newmo,newdy,newhr,newmn,newsc);


  exit(0);
}

int md2yd(int yr,int mo,int dy){
/* a small function to calculate
 *	year day(total day) from year, month, day
 *	(1/1=1)
 */
	int leap,yd;
	//XXXXleap=((yr % 4) ? 1 : 0);
	leap=(yr%4==0);
	if ( yr % 100  == 0 ) leap=0;
	if ( yr % 400  == 0 ) leap=1;
	if ( mo <   0 )yd=0;
	if ( mo >  12 )yd=0;
	if ( mo ==  0 )yd=0;
	if ( mo ==  1 )yd=dy;
	if ( mo ==  2 )yd=dy+31;
	if ( mo ==  3 )yd=dy+leap+59;
	if ( mo ==  4 )yd=dy+leap+90;
	if ( mo ==  5 )yd=dy+leap+120;
	if ( mo ==  6 )yd=dy+leap+151;
	if ( mo ==  7 )yd=dy+leap+181;
	if ( mo ==  8 )yd=dy+leap+212;
	if ( mo ==  9 )yd=dy+leap+243;
	if ( mo == 10 )yd=dy+leap+273;
	if ( mo == 11 )yd=dy+leap+304;
	if ( mo == 12 )yd=dy+leap+334;

	//printf("yr=%d,mo=%d,dy=%d => yd=%d\n",yr,mo,dy,yd);

	return yd;
}

void monday(int *yr,int *mon,int *mday,int *yday) {
/* a small function to calculate
 *	mon (1-12), mday (1-31)  from  yr,yday(Jan.1=1)
 *				by Sessai@NIPR
 */

        int leap;

	leap=(*yr%4==0);
	if ( *yr % 100  == 0 ) leap=0;
	if ( *yr % 400  == 0 ) leap=1;

	if     (*yday <  1)     {*mon= 0;*mday=0;}
	else if(*yday<= 31)     {*mon= 1;*mday=*yday;}
	else if(*yday<= 59+leap){*mon= 2;*mday=*yday- 31;}
	else if(*yday<= 90+leap){*mon= 3;*mday=*yday- 59-leap;}
	else if(*yday<=120+leap){*mon= 4;*mday=*yday- 90-leap;}
	else if(*yday<=151+leap){*mon= 5;*mday=*yday-120-leap;}
	else if(*yday<=181+leap){*mon= 6;*mday=*yday-151-leap;}
	else if(*yday<=212+leap){*mon= 7;*mday=*yday-181-leap;}
	else if(*yday<=243+leap){*mon= 8;*mday=*yday-212-leap;}
	else if(*yday<=273+leap){*mon= 9;*mday=*yday-243-leap;}
	else if(*yday<=304+leap){*mon=10;*mday=*yday-273-leap;}
	else if(*yday<=334+leap){*mon=11;*mday=*yday-304-leap;}
	else if(*yday<=365+leap){*mon=12;*mday=*yday-334-leap;}
	else                    {*mon=0;*mday=0;}
        return;
}

