#ifdef __USAGE
%C - convert year and yearday to year, month and day
%C [-c|-s] yyyy yd
	yyyy : 4 digit year
	 yd  : day of year (Jan. 1 = 1 (not 0!!) (1,2,3,...,365(,366))
	output will be "yyyy mo dy" if no option(-c/-s) specified
	               "yyyymmdd"   if '-c' option specified
	               "yyyy/mo/dy" if '-s' option specified
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>	//for basename();

#define  SECS_PER_DAY 86400L /* number of seconds per day */

#if 0
void usage(int argc,char *argv[]){
	fprintf(stderr,"%s - convert year and yearday to year, month & day\n",basename(argv[0]));
	fprintf(stderr,"\t%s [-c|-s] yyyy yd\n",basename(argv[0]));
	fprintf(stderr,"\t\tyyyy : 4 digit year\n");
	fprintf(stderr,"\t\t yd  : day of year (Jan. 1 = 1(not 0!!)(1,2,3,...,365(,366))\n");
	fprintf(stderr,"\t\toutput will be yyyy mo dy if no option(-c/-s) specified\n");
	fprintf(stderr,"\t\toutput will be yyyymmdd   if \'-c\' option specified\n");
	fprintf(stderr,"\t\toutput will be yyyy/mm/dd if \'-s\' option specified\n");
	exit(-1);
}
#else
void usage(int argc,char *argv[]){
	char cmd[48];
	strcpy(cmd,"use ");
	strcat(cmd,argv[0]);
	strcat(cmd," 1>&2");
	system(cmd);
	exit(-1);
}
#endif

void main(int argc,char *argv[]){

	int yr,mo,dy,lp,yd;
#if 0
	int mo2,dy2;
	struct tm tms;
	unsigned long tv_sec;
#endif
	int mode=0,optflag=0;

	if(argc==1)usage(argc,argv);
	if(strcmp(argv[1],"-c")==0){mode=1;optflag=1;}
	if(strcmp(argv[1],"-s")==0){mode=2;optflag=1;}

	//if(argc<3+optflag)usage(argc,argv);
	if(argc != 3+optflag)usage(argc,argv);

	yr=atoi(argv[1+optflag]);	// must be 4 digit!!!
	yd=atoi(argv[2+optflag]);

	lp=(yr%4==0);
	if ( yr % 100  == 0 ) lp=0;
	if ( yr % 400  == 0 ) lp=1;

	if((yd<1)||(yd>365+lp)){
		fprintf(stderr,"day must be between 1 and %d for year=%d\n",
			365+lp,yr);
		usage(argc,argv);
	}

#if 0
	tms.tm_year=yr-1900;
	tms.tm_yday=yd-1;	// Jan 1 = 0!!
	tms.tm_hour=0;
	tms.tm_min=0;
	tms.tm_sec=0;
	tms.tm_isdst=0;

	tv_sec=mktime(&tms);

	mo2=tms.tm_mon;
	dy2=tms.tm_mday;

	fprintf(stdout,"%d %d %d\n",yr,mo2,dy2);
#endif

	monday(&yr,&mo,&dy,&yd);	// yd=1 means Jan.1

	if(mode==0) fprintf(stdout,"%d %d %d\n",yr,mo,dy);
	if(mode==1) fprintf(stdout,"%04d%02d%02d\n",yr,mo,dy);
	if(mode==2) fprintf(stdout,"%d/%02d/%02d\n",yr,mo,dy);

#if 0
	if((mo2 == mo)&&(dy2==dy)){
		fprintf(stdout,"%d %d %d\n",yr,mo,dy);
	} else {
		fprintf(stdout,"%d %d %d\n",yr,mo,dy);
		fprintf(stderr,"%d/%d(by mktime) != %d/%d(by mine)\n",
			mo2,dy2,mo,dy);
		fprintf(stderr,"Abnormal result...\n");
		exit(-1);
	}
#endif

	exit(0);

}

int md2yd(int yr,int mo,int dy){
/* a small function to calculate
 *	year day(total day) from year, month, day
 *	(1/1=1)
 */
	int leap,yd;
	//XXXXleap=((yr % 4) ? 1 : 0);
	leap=(yr%4==0);
	if ( yr % 100  == 0 ) leap=0;
	if ( yr % 400  == 0 ) leap=1;
	if ( mo <   0 )yd=0;
	if ( mo >  12 )yd=0;
	if ( mo ==  0 )yd=0;
	if ( mo ==  1 )yd=dy;
	if ( mo ==  2 )yd=dy+31;
	if ( mo ==  3 )yd=dy+leap+59;
	if ( mo ==  4 )yd=dy+leap+90;
	if ( mo ==  5 )yd=dy+leap+120;
	if ( mo ==  6 )yd=dy+leap+151;
	if ( mo ==  7 )yd=dy+leap+181;
	if ( mo ==  8 )yd=dy+leap+212;
	if ( mo ==  9 )yd=dy+leap+243;
	if ( mo == 10 )yd=dy+leap+273;
	if ( mo == 11 )yd=dy+leap+304;
	if ( mo == 12 )yd=dy+leap+334;

	//printf("yr=%d,mo=%d,dy=%d => yd=%d\n",yr,mo,dy,yd);

	return yd;
}

void monday(int *yr,int *mon,int *mday,int *yday) {
/* a small function to calculate
 *	mon (1-12), mday (1-31)  from  yr,yday(Jan.1=1)
 *				by Sessai@NIPR
 */

        int leap;

	leap=(*yr%4==0);
	if ( *yr % 100  == 0 ) leap=0;
	if ( *yr % 400  == 0 ) leap=1;

	if     (*yday <  1)     {*mon= 0;*mday=0;}
	else if(*yday<= 31)     {*mon= 1;*mday=*yday;}
	else if(*yday<= 59+leap){*mon= 2;*mday=*yday- 31;}
	else if(*yday<= 90+leap){*mon= 3;*mday=*yday- 59-leap;}
	else if(*yday<=120+leap){*mon= 4;*mday=*yday- 90-leap;}
	else if(*yday<=151+leap){*mon= 5;*mday=*yday-120-leap;}
	else if(*yday<=181+leap){*mon= 6;*mday=*yday-151-leap;}
	else if(*yday<=212+leap){*mon= 7;*mday=*yday-181-leap;}
	else if(*yday<=243+leap){*mon= 8;*mday=*yday-212-leap;}
	else if(*yday<=273+leap){*mon= 9;*mday=*yday-243-leap;}
	else if(*yday<=304+leap){*mon=10;*mday=*yday-273-leap;}
	else if(*yday<=334+leap){*mon=11;*mday=*yday-304-leap;}
	else if(*yday<=365+leap){*mon=12;*mday=*yday-334-leap;}
	else                    {*mon=0;*mday=0;}
        return;
}

